// source-lazy-file: A file lazily loaded to memory
//
// This data source is a regular file that is not loaded to RAM; only the front
// buffer is loaded. Because we don't control the entire file, this source does
// not support any size-changing capability.

#pragma once
#include <stddef.h>

typedef struct {
    /* Open file descriptor */
    int fd;
    /* File size */
    int size;

} lazy_file_t;

source_t *source_lazy_file_open(char const *path);
