// source-memory: A region of memory
//
// This data source is just a chunk of virtual memory. Be careful that memory
// is very volatile and the hex editor doesn't update automatically.

#pragma once
#include <stddef.h>

typedef struct {
    /* Start and end addresses */
    uint32_t start, end;
    /* Whether that particular region is writable */
    bool writable;
    /* Region name */
    char const *name;

} memory_region_t;

/* All memory regions (NULL terminated) */
extern memory_region_t *memory_all_regions[];

source_t *source_memory_open(memory_region_t *region);
