// util: Global utility functions

#pragma once
#include <stdbool.h>

/* Show the "please wait" popup message over the current display. This gets
   overridden at the next application frame. Does draw to VRAM. */
void please_wait(void);

/* Show the "unsaved changes" popup. */
bool confirm_discard(void);

/* Human version of file sizes. If str=NULL, returns a static buffer that is
   overridden by further calls. */
char const *human_size(int size, char *str);

/* Human version of file sizes with SI units. */
char const *human_isize(int size, char *str);
